Issue 20857 - R1C1 notation for the spreadsheet
Summary: R1C1 notation for the spreadsheet
Status: ACCEPTED
Alias: None
Product: Calc
Classification: Application
Component: code (show other issues)
Version: OOo 1.1
Hardware: All All
: P3 Trivial with 103 votes (vote)
Target Milestone: ---
Assignee: AOO issues mailing list
QA Contact:
URL:
Keywords:
: 66161 67219 (view as issue list)
Depends on: 72191 69883 107338
Blocks: 59362 71455 49499 72190
  Show dependency tree
 
Reported: 2003-10-07 22:06 UTC by apperrin
Modified: 2013-08-07 15:13 UTC (History)
19 users (show)

See Also:
Issue Type: FEATURE
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments

Note You need to log in before you can comment on or make changes to this issue.
Description apperrin 2003-10-07 22:06:44 UTC
Could the R1C1 notation be added to oocalc ? I never used the A1 notation in
Excel because of its lack of readability. For me the R1C1 notation is much more
explicit and easy to read... and a bunch of identical formulas can be compared
more quickly...

Example :
=RC(-1)+1
=RC(-1)+1
=RC(-1)+1
=RC(-1)+1

is easier to reread than
=A1+1
=B1+1
=C1+1
=D1+1

As a matter of fact this R1C1 notation is even translated. I'm french and in the
french version of Excel, it L1C1 (L=ligne (french)=row and C=colonne
(french)=column). So in R1C1 notation, the letter for the rows and the letter
for the columns could be parametered...
Comment 1 frank 2003-10-08 09:57:27 UTC
Hi Bettina,

1 4 u.

IMHO the current behaviour is more convenied as the described one.

Frank
Comment 2 hardlogic 2004-06-30 01:57:02 UTC
For a well-reasoned rationale for using R1C1, see:
http://media.wiley.com/product_data/excerpt/0X/07645412/076454120X.pdf

Many people may well prefer A1 notation (even after having read the above), and
of course the idea is to have a choice (ala Excel) rather than to force a switch.

A further point in favor of the feature option is that it is likely to be
something that power users and developers (i.e. users in a position to influence
switchover decisions) may find to be a sticking point.  I humbly suggest that it
would be a good idea to remove objections before they result in users that
decide against OO, rather than after.
Comment 3 jodygoldberg 2005-07-27 17:25:15 UTC
I've got a preliminary patch that adds R1C1 style notation support.  I'll attach
i t here when the 3d ref support is fixed, and I've patched the rest of the
calls to the Parser and Formater to use the correct convention.

It will be interesting to discuss the best notation for sheet references in R1C1
format.  MS Excel does not need to contend with relative vs absolute sheet refs,
and the OOo std $sheet!addr seems inconsistent in R1C1 form for relative sheets
where we would end up with
    sheet!r1c1
as opposed to something more consistent like (and I'm just making this up)
    S[-1]!R1C1
or
    S[-1]R1C1

While I'm in here I'm also adding support for full col and full row references
so that things like R1:R2 or C:C4 work.

Sheet!R1C1
Comment 4 bryceman 2005-10-24 17:55:20 UTC
Hmm... whatever happened to that patch? The inclusion of the full row / column
referencing would be really nice (read better compatibility w/Excel)! Of course
that brings up UI issues - row / column headers should be selectable when
editing formulas.
Comment 5 guybk 2005-11-10 16:38:18 UTC
It's not only compatibility: the points made in the Wiley book linked to by
hardlogic are well-made, and they state all the things I would want to say about
why R1C1 is a must for OOo (especially for spreadsheet power-users).  Can we get
that patch in sometime soon, please?

Regards,

Guy.
Comment 6 jodygoldberg 2005-11-10 17:14:55 UTC
development is still underway on the patch.
A CWS has been created for it, but only about 2/3 of the sc module currently
builds.  This change modifies quite a bit of low level api.
Comment 7 frank 2005-12-15 09:28:09 UTC
*** Issue 59362 has been marked as a duplicate of this issue. ***
Comment 8 ooo 2005-12-16 13:43:30 UTC
Actually this is more a complete feature than an enhancement.

Reassigning ownership to Jody, as he's already working on it.
Comment 9 frank 2006-06-06 13:30:48 UTC
*** Issue 66161 has been marked as a duplicate of this issue. ***
Comment 10 frank 2006-07-27 14:46:01 UTC
*** Issue 67219 has been marked as a duplicate of this issue. ***
Comment 11 ooo 2006-09-26 15:09:32 UTC
Created subtask issue 69883.
Comment 12 oooforum (fr) 2007-09-03 11:52:54 UTC
This feature exists in Novell Edition. 
Comment 13 kyoshida 2008-01-04 00:34:07 UTC
@er:

We have a patch for this feature that we've been using in ooo-build forever.  Is
anyone upstreaming it (or should I?)
Comment 14 ooo 2008-01-14 13:19:31 UTC
@kohei: Having this still assigned to Jody IMHO doesn't make sense, so I
reassigned to you.

Note that the core part was already upstreamed, see issue 69883. Missing is the
UI specification, for which there is a separate issue 72191. Unfortunately 'mmp'
whom the issue was assigned to doesn't work anymore with the UX team, so that
should get pushed again on the request@ux mailing list, see also
http://wiki.services.openoffice.org/wiki/HowTo_Request_User_Experience_Assistance#How_to_contact_UX_.2F_how_to_request_assistance

However, from the past I remember that there were several issues related to the
R1C1 notation enabled in go-oo/Novell releases, don't know details though. Have
these been fixed and are the fixes part of the patch mentioned?
Comment 15 kpalagin 2008-02-10 18:18:40 UTC
I have created UI specification and attached it to 
http://www.openoffice.org/issues/show_bug.cgi?id=72191.
Please take a look and comment ASAP, so that we can implement this for 3.0.

Thanks a lot.
WBR,
K. Palagin.
Comment 16 kpalagin 2008-02-12 18:02:05 UTC
Updated UI spec 
http://www.openoffice.org/nonav/issues/showattachment.cgi/51469/i72191spec3.odt
.
Please comment.
Comment 17 kyoshida 2008-02-12 18:25:51 UTC
@er: I'm not sure what the issues were with the current R1C1 patch in the
ooo-build/go-oo version, but since no one has done any work on it after Jody's
departure, I'm pretty sure the issues still remain.  I'll have to look into that.

Schedule-wise, I'll be honest with you, I can't guarantee the inclusion of this
feature for 3.0, but I'll do what I can as time permits.  I'm also working on a
feature that enables argument separator switch (so that those who are coming
from Excel can use ',' instead of ';' to separate arguments in appropriate
locales), so I'll try to combine that with the integration of R1C1.

UI-wise, I think using the drop-down combo box instead of grouped radio buttons
would make more sense, to make it easier to add a new address type in the future.
Comment 18 kyoshida 2008-02-12 18:26:23 UTC
Set it to 3.0.
Comment 19 kpalagin 2008-02-13 20:10:00 UTC
Kohei,
thank you very much for being agressive with the target - OpenOffice.org 
project needs this agility!!!
I will update the spec to reflect the proposed UI and correct typos.
Comment 20 kyoshida 2008-03-21 05:07:34 UTC
Sorry folks.  I won't be able to make it for 3.0, only because of the string
freeze. :-(

The game plan is to put the underlying implementation code in for 3.0, and put
the UI in for 3.1.  Work in ongoing in koheiformula01 CWS.
Comment 21 kpalagin 2008-04-25 18:20:52 UTC
Kohei,
could you, by chance, finish implementation sometime soon, so that we don't 
miss 3.1 too?

Thanks a ton.
WBR,
KP.
Comment 22 kyoshida 2008-04-25 19:44:12 UTC
Yeah I'm working on it as we speak, in koheiformula01.  But I may have missed
the deadline for 3.0 to integrate the core part of this feature, due to windows
build difficulties.
Comment 23 frank.loehmann 2008-05-22 09:32:00 UTC
This issue is important and listed on the quarterly review for Calc:
http://wiki.services.openoffice.org/wiki/2008_Q2_Review_of_Spreadsheet_Project
Comment 24 kpalagin 2008-06-23 10:16:36 UTC
I sorry for being so pushy about this issue, but I do beleive that great 
effort of introducing R1C1 into Calc should be put in use ASAP. So I really 
would like integration of koheiformula01 as early as possible, in order to 
avoid our usual last minute retargets.
Comment 25 kyoshida 2008-06-25 15:39:47 UTC
@kpalagin: FWIW, koheiformula01 is already integrated into the main tree, so the
remaining issue right now is to work out the UI as well as any other issues that
might come up as we expose R1C1 to the masses.

When is the feature freeze for 3.1? (does anyone know off hand?)
Comment 26 ooo 2008-06-25 16:23:19 UTC
@kohei: There's no OOo3.1 schedule yet, stay tuned to
http://wiki.services.openoffice.org/wiki/Product_Release
Comment 27 kpalagin 2008-06-26 09:35:33 UTC
Kohei,
sorry for confusion. I ment UI changes.
UI freeze is at Novemeber 27th, 2008 
(http://wiki.services.openoffice.org/wiki/OOoRelease31), which will come 
sooner than it appears.
Comment 28 dzurn 2010-04-12 20:38:27 UTC
Has there been any movement on this issue? Last milestone attempted was June 2008.
Comment 29 fabioprogman 2010-09-12 17:00:18 UTC
Is also very useful display the labels of the columns in R1C1 style.
The R1C1 format is very convenient for working with record scheme (for example).
Comment 30 fabioprogman 2010-09-12 17:02:32 UTC
Regards
Comment 31 apperrin 2010-09-12 19:56:33 UTC
I opened this ticket *seven years ago* !!! Since then, R1C1 notation has never
been fully functional in OpenOffice.org. Could a developer explain to me why
this matter takes so long to be dealt with ? Please !!
Comment 32 webpac 2010-09-12 21:43:59 UTC
It's a feature important for a spreadsheet, I'm waiting it 5 years ago, it's a 
scandal !
It was expected in 2.0, then 2.1, then 2.x, then 3.0, ... and now OOo 3.4 but 
when the 3.4 will be realesed, it'll be in 3.5 or 4.0 target milestone.
Comment 33 opium13 2010-09-13 12:28:56 UTC
impossible d'utiliser openoffice tant que la notation R1C1 (a défaut de L1C1) ne
sera pas opérationnelle.
je le regrettes beaucoup, croyez moi
Comment 34 taklecker 2010-11-28 14:40:39 UTC
I too am disappointed that r1c1 UI has not yet been implemented in OpenOffice
Calc and have been waiting for the now long delayed debut.

I work in a professional environment and would love to advocate OpenOffice Calc
as a serious contender with Microsoft Excel.  But the lack of support for this
common UI feature leads to an impression of the application being "not ready for
the big leagues", that it isn't 'serious' software.  An impression that is hard
to explain away.

I have enough of a technical background to understand that this is just a UI
issue.  The referencing to columns by letters vs numbers is irrelevant to
program execution.  The data of cell references are manipulated as binary values
which are then translated to either '1A' or 'r1c1' for the user.  And the user's
cell reference entry is translated to binary values for purposes of program
execution.

I work with 'power users' who shun the '1A' referencing due to the need to
frequently use relative column references in formulas.  Using alphabetical
column references would necessitate frequent manual conversion from alphabetic
to the numeric value to perform the offset calculation.  That is a ridiculous
waste of time that doesn't stand up in productivity and performance reviews.

I wonder if the postponing and low prioritization of this feature is indicative
of a 'culture' problem.  I see references in the OpenOffice 'blogosphere' to
'r1c1' notation as being 'old' and 'older'.

I do accounting, among other things.  Accountants daily use terms and concepts
that were invented over five hundred years ago.  'Debits' and 'Credits' will not
become obsolete due to age.

Neither will 'r1c1' notation.
Comment 35 hooperw 2010-11-29 20:26:35 UTC
I have been voting for this issue for several years as well, and cannot leave
Excel until it's fixed.  I appreciate the voluntary labor that goes into OoO,
and I realize that the limited programming time available has to go into the
most urgent issues first.

I notice that this issue, 20857, has 96 votes, but that it's resolution depends
on issue 72191, which only has 15 votes.  I would encourage all of you for whom
R1C1 is important to cast as many votes for both issues as your allotment allows.
Comment 36 grummund 2010-11-29 20:56:54 UTC
I'm not sure why R1C1 notation would be referred to as "old" or "older".  If
anything, A1 notation is the legacy - a relic from the days of Lotus-1-2-3 and
Supercalc.

I have voted for issue 72191.  In a way that issue is slightly misleading as it
presents this as a compatibility issue with Excel, which it is not.  

This is about getting OOo to be taken seriously by power users, a significant
proportion of which actually use R1C1 (in Excel) because it makes sense even
though that program does a good job of hiding the feature away.  OOo can do
better at promoting the feature I'm sure.

It's not clear the dependency on 72191, some developer comment on this issue
would be interesting to follow.

Ok, rant over. ;) and thanks to all the developers for their hard work.
Comment 37 pstrg 2010-12-16 16:19:41 UTC
Novell's latest edition 3.2.1 (2010-09-16), does have support for matrix (R1C1)
notation in Calc.
That non-crippled build may be downloaded here:
 http://download.novell.com/index.jsp?product_id=&search=Search&families=3402
Comment 38 pstrg 2011-02-06 02:02:32 UTC
In case anyone missed this: LibreOffice 3.3.0, published about a week ago, has R1C1.
Comment 39 cataldo+ooo 2013-02-07 19:58:14 UTC
I made an account pretty much just so I could vote for this issue (and the issue that blocks this).  Killer feature.
Comment 40 Rob Weir 2013-07-30 02:37:25 UTC
Reset assignee on issues not touched by assignee in more than 1000 days.